/**************************************************************
 *
 *  MimeTeX API
 *  
 *  
 *
 *  Revisions:
 *
 *  2009/08/21 by lightbell
 *
 *  to do list :
 *
 *
 **************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "mimetex.h"

enum RETURN_Code {
    OK = 0,
	MIMETEX_ERROR,
    GIF_ERROR    
};

#if defined(TEXFONTS)
/* --- global needed by callback function, below, for gifsave.c --- */
static  subraster *sp = NULL; 
static  raster *rp = NULL;              /* 0/1 bitmap raster image */

/* ---  callback function to return pixel value at col x, row y --- */
int     GetPixel ( int x, int y )       /* pixel value will be 0 or 1 */
{ return (int)getpixel(rp,y,x); }       /* just use getpixel() macro */



/* --- main() entry point --- */
/**
 * latex ǥ ̹ ȯ
 * @param	filename	θ   ϸ
 * @param	expression	latex ǥ
 * @return	0: , 1:mimetexȯ, 2: ̹ȯ
 */
int	equation (char *filename, char *expression)
{

	int ret = OK;
	/* --- get LaTeX expression from either browser query or command-line --- */
	char  *query = getenv("QUERY_STRING");        /* check for query string 
												 */
    char* temp;
	
	if( expression != NULL ) {
		temp = (char*)malloc(strlen(expression)*10);
		if ( temp != NULL ) {
			strcpy(temp, expression);
			mimeprep(temp);

			/* ---- mimeTeX converts expression to bitmap raster ---- */
			sp = make_raster(temp,NORMALSIZE); /* mimeTeX rasterizes expression */
			free(temp);
		
		}		
	}
		
	if ( sp != ( subraster * ) NULL ) 
    {	
		rp = sp->image;	

		/* ---- convert returned bitmap raster to gif, and emit it on stdout ---- */
		if ( query != NULL )                    /* Content-type line for browser */
			fprintf( stdout, "Content-type: image/gif\n\n" );
		
		/* --- initialize gifsave library and colors, and set transparent bg --- */


		//GIF_Create(NULL, rp->width, rp->height, 2, 8); /* init for black/white */
		ret = GIF_Create(filename, rp->width, rp->height, 2, 8); /* init for black/white */
		if( ret != OK ) {
			return GIF_ERROR;
		}
		GIF_SetColor(0, 255, 255, 255);         /* always set background white */
		GIF_SetColor(1,   0,   0,   0);         /* and foreground black */
		ret = GIF_SetTransparent(0);                  /* and set transparent background */
		if( ret != OK ) {
			return GIF_ERROR;
		}
		/* --- finally, emit compressed gif image (to stdout) --- */
		ret = GIF_CompressImage(0, 0, -1, -1, GetPixel);
		if( ret != OK ) {
			return GIF_ERROR;
		}
		ret = GIF_Close();
		if( ret != OK ) {
			return GIF_ERROR;
		}
		
		ret = delete_subraster ( sp );		
		if( ret == 0 ) { // 1 if completed successfully or 0 otherwise (for any error).
			return MIMETEX_ERROR;
		}else{
			ret = 0;
		}
	}else{
		return MIMETEX_ERROR;
	}
	return ret;	
 }


int main ( int argc, char *argv[]) {
	int ret = OK;
	if(argc == 3){	
		// filepath, expression
		ret = equation(argv[1], argv[2]);
	}else{

#ifdef WIN32
		//printf("equation.exe <output_file> [<expression>]\n");
#else
		//printf("equation_exe <output_file> [<expression>]\n");
#endif

	}		
	return ret;	
}

#endif
